unit kilibmanageru;

interface

uses
  LibraryU, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ComCtrls, ExtCtrls;

const
  KLM_VERS		= 0 * 10 + 9;			// vers 0.8

type
  TfmMain = class(TForm)
    MainMenu1: TMainMenu;
    Program1: TMenuItem;
    Openlibrary1: TMenuItem;
    mnLayout: TMenuItem;
    mnTile: TMenuItem;
    mnCascade: TMenuItem;
    Minimizeall1: TMenuItem;
    UnMinimize1: TMenuItem;
    sbStatus: TStatusBar;
    mnNewone: TMenuItem;
    N1: TMenuItem;
	Save1: TMenuItem;
    Saveas1: TMenuItem;
	N2: TMenuItem;
	Exit1: TMenuItem;
	Edit1: TMenuItem;
	mnUndo: TMenuItem;
	mnTileHoriz: TMenuItem;
	N3: TMenuItem;
	N4: TMenuItem;
	mnSwap: TMenuItem;
	Layout11: TMenuItem;
	Layout21: TMenuItem;
    N5: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Cut1: TMenuItem;
    Paste2: TMenuItem;
    mnWindows: TMenuItem;
    tmRefwin: TTimer;
    Libraryfromsearchfiles1: TMenuItem;
    dlgOpen: TOpenDialog;
    About1: TMenuItem;
    HelpAbout1: TMenuItem;
	procedure FormShow(Sender: TObject);
	procedure Openlibrary1Click(Sender: TObject);
	procedure mnTileClick(Sender: TObject);
	procedure mnCascadeClick(Sender: TObject);
	procedure Minimizeall1Click(Sender: TObject);
	procedure UnMinimize1Click(Sender: TObject);
	procedure mnNewoneClick(Sender: TObject);
	procedure Save1Click(Sender: TObject);
	procedure mnTileHorizClick(Sender: TObject);
	procedure mnSwapClick(Sender: TObject);
	procedure Layout11Click(Sender: TObject);
	procedure Layout21Click(Sender: TObject);
	procedure mnUndoClick(Sender: TObject);
	procedure mess(st: string);
	procedure Saveas1Click(Sender: TObject);
	procedure Copy1Click(Sender: TObject);
	procedure Paste1Click(Sender: TObject);
	procedure Cut1Click(Sender: TObject);
	procedure Paste2Click(Sender: TObject);
	procedure RefreshMenuWin;
	procedure WinClick(Sender: TObject);
	procedure tmRefwinTimer(Sender: TObject);
	procedure Exit1Click(Sender: TObject);
	procedure Libraryfromsearchfiles1Click(Sender: TObject);
	procedure searchterm(path: string);
    procedure HelpAbout1Click(Sender: TObject);
  private
	{ Private declarations }
	procedure AcceptDrop(var message: TMessage); message WM_DROPFILES;

  public
	{ Public declarations }
  end;

var
  fmMain	: TfmMain;

  // undo
  kcboard	: TList;			// list of items to undo
  winkcdel	: TfmLibrary;		// where to put items
  winkcput	: TfmLibrary;		// where to delete items
  (*
	winkcdel<>NIL:
	  if winkcput=NIL, was a delete or cut from winkcdel
	  if winkcput<>NIL, items were added to winkcput: delete

	if winkcput<>NIL, items were added to it; delete
  *)

  lastsearch	: string;

implementation
Uses TxtIntface, aboutu;

{$R *.dfm}

procedure DragAcceptFiles(hwnd: THandle; acc: bool); stdcall; external 'shell32.dll';

procedure TfmMain.FormShow(Sender: TObject);
var
  anew	: TfmLibrary;
  fn	: string;

begin
  kcboard := TList.Create;
  winkcdel := NIL;
  winkcput := NIL;

  caption := 'KiCAD Library manager v'+format('%d.%2.1d', [KLM_VERS div 10, KLM_VERS mod 10]);
  if paramstr(1)<>'' then begin
	fn := ExpandFileName(paramstr(1));
	anew := TfmLibrary.create(self);
	anew.LoadFile(fn);
	// tile
  end;
  DragAcceptFiles(handle,true);
end;

procedure TfmMain.mnTileClick(Sender: TObject);
begin
  if MDIChildCount=0 then exit;
  tile;
  TfmLibrary(MDIChildren[0]).DoLayout2;
  if MDIChildCount<2 then exit;
  TfmLibrary(MDIChildren[1]).DoLayout2;
end;

procedure TfmMain.mnCascadeClick(Sender: TObject);
var
  i		: integer;

begin
  cascade;
  for i := 0 to MDIChildCount-1 do TfmLibrary(MDIChildren[i]).DoLayout2;
end;

procedure TfmMain.Minimizeall1Click(Sender: TObject);
var
  i		: integer;

begin
  if MDIChildCount=0 then exit;
  for i := 0 to MDIChildCount-1 do MDIChildren[i].WindowState := wsMinimized;
  MDIChildren[0].WindowState := wsMinimized;
  ArrangeIcons;
  ArrangeIcons
end;

procedure TfmMain.UnMinimize1Click(Sender: TObject);
var
  i		: integer;

begin
  if MDIChildCount=0 then exit;
  for i := 0 to MDIChildCount-1 do MDIChildren[i].WindowState := wsNormal;
end;

procedure TfmMain.Openlibrary1Click(Sender: TObject);
var
  anew	: TfmLibrary;

begin
  anew := TfmLibrary.create(self);
  anew.LoadAskFile;
end;

function  DragQueryFile(droph: THandle; index: integer; name: PChar; len: cardinal): cardinal; stdcall; external 'shell32.dll';
procedure DragFinish(droph: THandle); stdcall; external 'shell32.dll';

procedure TfmMain.AcceptDrop(var message: TMessage);
var
  droph			: THandle;
  i,ifil		: integer;
  myfilename	: string;
  name			: PChar;
  anew			: TfmLibrary;
  count			: integer;

begin
  // passo 1: prelevare il conteggio dei file
  droph := message.wParam;
  count := DragQueryFile(droph,-1,NIL,0);
  for ifil := 0 to count-1 do begin
	i := DragQueryFile(droph,ifil,NIL,0);
	name := StrAlloc(i+1);
	DragQueryFile(droph,ifil,Name,i+1);
	myfilename := StrPas(Name);
	StrDispose(name);
	application.BringToFront;

	if uppercase(extractfileext(myfilename))<>'.LIB' then continue;

	mess('Opening '+myfilename);
	anew := TfmLibrary.create(self);
	anew.LoadFile(myfilename)
  end;
  DragFinish(droph);
  mess('Opened '+inttostr(count)+' files.');
end;

procedure TfmMain.mnNewoneClick(Sender: TObject);
begin
  TfmLibrary.create(self);
end;

procedure TfmMain.Save1Click(Sender: TObject);
begin
  TfmLibrary(ActiveMDIChild).Save
end;

procedure TfmMain.mnTileHorizClick(Sender: TObject);
var
  brd	: integer;
  ht	: integer;

begin
  if MDIChildCount<1 then exit;

  brd := GetSystemMetrics(SM_CYBORDER);
  ht  := GetSystemMetrics(SM_CYMINIMIZED)+4*brd;
  with TfmLibrary(MDIChildren[0]) do begin
	left := 0;
	top := 0;
	width := fmMain.ClientWidth div 2-4*brd;
	height := fmMain.ClientHeight - ht;
	DoLayout1
  end;
  if MDIChildCount<2 then exit;
  with TfmLibrary(MDIChildren[1]) do begin
	left := fmMain.ClientWidth div 2;
	top := 0;
	width := fmMain.ClientWidth div 2-4*brd;
	height := fmMain.ClientHeight - ht;
	DoLayout1
  end;

end;

procedure TfmMain.mnSwapClick(Sender: TObject);
begin
  if MDIChildCount<2 then exit;
  Next;
  mnTileHorizClick(NIL)
end;

procedure TfmMain.Layout11Click(Sender: TObject);
begin
  if ActiveMDIChild=NIL then exit;
  TfmLibrary(ActiveMDIChild).DoLayout1
end;

procedure TfmMain.Layout21Click(Sender: TObject);
begin
  if ActiveMDIChild=NIL then exit;
  TfmLibrary(ActiveMDIChild).DoLayout2
end;

procedure TfmMain.mess(st: string);
begin
  sbStatus.Panels[sbStatus.Panels.Count-1].Text := st;
  application.ProcessMessages
end;

procedure TfmMain.mnUndoClick(Sender: TObject);
var
  i		: integer;

begin
  (*
	winkcdel<>NIL:
	  if winkcput=NIL, was a delete or cut from winkcdel
	  if winkcput<>NIL, items were added to winkcput: delete

	if winkcput<>NIL, items were added to it; delete
  *)

  if (winkcdel=NIL) and (winkcput=NIL) then exit;
  if kcBoard.Count=0 then exit;

  // add again to winkcdel
  if winkcdel<>NIL then begin
	// items were deleted from here
	mess('Restored '+inttostr(kcBoard.Count)+' components.');
	with winkcdel
	  do for i := 0 to kcBoard.Count-1
		do KiComps.Add(kcboard[i]);
	winkcdel.BringToFront;
	winkcdel.refresh
  end else begin
	// items were not subtracted from anywhere - it was a paste
	mess('Deleted '+inttostr(kcBoard.Count)+' that were pasted.')
  end;

  if winkcput<>NIL then begin
	with TfmLibrary(winkcput)
	  do for i := kcBoard.Count-1 downto 0
		do KiComps.Remove(kcboard[i]);
	if winkcdel=NIL then winkcput.BringToFront;
	winkcput.refresh
  end;

  // determine whether clear the list: yes, but not if it was a single paste
  if winkcdel<>NIL then begin
	while kcBoard.Count<>0 do kcBoard.Delete(kcBoard.Count-1)
  end;
  winkcdel := NIL;
  winkcput := NIL;
  mnUndo.Enabled := false
end;

procedure TfmMain.Saveas1Click(Sender: TObject);
begin
  TfmLibrary(ActiveMDIChild).SaveAs
end;

procedure TfmMain.Copy1Click(Sender: TObject);
begin
  if ActiveMDIChild<>NIL then TfmLibrary(ActiveMDIChild).mnCopy1Click(NIL);
end;

procedure TfmMain.Paste1Click(Sender: TObject);
begin
  if ActiveMDIChild<>NIL then TfmLibrary(ActiveMDIChild).mnPaste1Click(NIL);
end;

procedure TfmMain.Cut1Click(Sender: TObject);
begin
  if ActiveMDIChild<>NIL then TfmLibrary(ActiveMDIChild).mnCut1Click(NIL);
end;

procedure TfmMain.Paste2Click(Sender: TObject);
begin
  if ActiveMDIChild<>NIL then TfmLibrary(ActiveMDIChild).mnDelete1Click(NIL);
end;

procedure TfmMain.RefreshMenuWin;
var
  i		: integer;
  men	: TMenuItem;

begin
  // delete all
  i := 0;
  while i<mnWindows.Count do begin
	if mnWindows.Items[i].Tag<>0
	  then mnWindows.Items[i].Free
	  else inc(i)
  end;

  for i := 0 to MDIChildCount-1 do begin
	men := TMenuItem.Create(self);
	men.Caption := TfmLibrary(MDIChildren[i]).caption;
	men.Tag := integer(MDIChildren[i]);
	men.OnClick := WinClick;
	mnWindows.Add(men)
  end
end;

procedure TfmMain.WinClick(Sender: TObject);
begin
  TForm(TMenuItem(sender).Tag).BringToFront
end;

procedure TfmMain.tmRefwinTimer(Sender: TObject);
begin
  tmRefWin.Enabled := false;
  RefreshMenuWin
end;

procedure TfmMain.Exit1Click(Sender: TObject);
begin
  close
end;

procedure AddPerhaps(cmp: TKiComponent);
var
  i		: integer;

begin
  for i := 0 to kcboard.Count-1 do begin
	if (cmp.name=TKiComponent(kcboard[i]).name) and (cmp.filename=TKiComponent(kcboard[i]).filename) then exit
  end;
  kcboard.Add(cmp)
end;

procedure LookInLib(fn, name: string);
var
  f		: TextFile;
  st	: string;
  cmp	: TKiComponent;

begin
  assign(f, fn);
  reset(f);
  if IOResult<>0 then exit;
  readln(f, st);
  if not IsKiCadLibProlog(st) then begin
	close(f);
	if IOResult<>0 then;
	exit
  end;

  repeat
	if IOResult<>0 then break;
	readln(f, st);
	comando := st;
	if separa='DEF' then begin
	  // perhaps a component
	  // if StrLike(uppercase(separa), name) then begin
	  if ( (name[1]=#0) and (uppercase(separa)=copy(name,2,1000)) )
		or
		SearchPassFilter(uppercase(separa), name) then begin
	  // if pos(name, uppercase(separa))<>0 then begin
		// it matches
		cmp := TKiComponent.LoadFromFile(f, st);
		cmp.filename := fn;
		AddPerhaps(cmp)
	  end
	end
  until eof(f);
  CloseFile(f);
  if IOResult<>0 then;
end;

procedure LookInDcm(fn: string);
var
  f		: TextFile;
  st	: string;
  cmp	: string;
  fld	: string;
  doit	: boolean;

begin
  assign(f, fn);
  reset(f);
  if IOResult<>0 then exit;
  readln(f, st);
  if not IsKiCadDcmProlog(st) then begin
	close(f);
	if IOResult<>0 then;
	exit
  end;

  cmp  := '';	// current name
  doit := false;
  repeat
	if IOResult<>0 then break;
	readln(f, st);
	comando := st;
	fld := separa;
	if cmp<>'' then begin
	  // we are inside a component. See if there is correspondance
	  if fld='D' then if SearchPassFilter(comando, uppercase(lastsearch)) then doit := true else
	  else if fld='#' then
	  else if fld='F' then
	  else if fld='K' then begin
		// search keywords
		repeat
		  if SearchPassFilter(separa, uppercase(lastsearch)) then doit := true;
		until comando=''
	  end else begin
		// finish with component
		if doit then begin
		  LookInLib(ChangeFileExt(fn,'.LIB'), #0+cmp);	// loads component
		  LoadDCM(kcboard, fn);
		end;
		cmp := ''
	  end
	end else begin
	  // look for a component
	  if fld='$CMP' then begin
		cmp := separa;
		doit := false
	  end
	end
  until eof(f);
  CloseFile(f);
  if IOResult<>0 then;
end;

procedure TfmMain.searchterm(path: string);
var
  rec	: TSearchRec;
  res	: integer;

begin
  // recursively search
  res := FindFirst(Path+'\*.lib', faAnyFile, rec);
  while res=0 do begin
	if rec.Attr and faDirectory<>0 then searchterm(path+'\'+rec.Name) else begin
	  // not a directory
	  if rec.Attr and faVolumeID=0 then begin
		// a file to search in
		LookInLib(path+'\'+rec.Name, uppercase(lastsearch))
	  end
	end;
	res := FindNext(rec)
  end;
  FindClose(rec);

  // now go for DCMs
  res := FindFirst(Path+'\*.dcm', faAnyFile, rec);
  while res=0 do begin
	if rec.Attr and faDirectory<>0 then searchterm(path+'\'+rec.Name) else begin
	  // not a directory
	  if rec.Attr and faVolumeID=0 then begin
		// a file to search in
		LookInDcm(path+'\'+rec.Name)
	  end
	end;
	res := FindNext(rec)
  end;
  FindClose(rec);
end;

procedure TfmMain.Libraryfromsearchfiles1Click(Sender: TObject);
var
  path	: string;
  anew	: TfmLibrary;
  i		: integer;

begin
  lastsearch := InputBox('Recursive directory search', 'Simple term to search for: ', lastsearch);
  if not dlgOpen.Execute then exit;
  path := ExtractFileDir(dlgOpen.FileName);

  kcboard.clear;
  screen.Cursor := crHourGlass;
  try
	searchterm(path);
  finally
	screen.Cursor := crDefault;
  end;

  if kcboard.Count=0 then begin
	Application.MessageBox(PChar('Nothing found for '+lastsearch), 'Search recursive');
	exit
  end;

  anew := TfmLibrary.create(self);
  for i := 0 to kcboard.Count-1 do anew.KiComps.Add(kcBoard[i]);
  anew.refresh;

  kcboard.Clear
end;

procedure TfmMain.HelpAbout1Click(Sender: TObject);
begin
  fmAbout.Show
end;

end.

